import oscP5.*;

class CYAClient { 
  OscP5 osc;
  HashMap cyapeople;
  PApplet parent;

  CYAClient (PApplet p, int port) {  
    parent = p;
    osc = new OscP5(this,port);
    cyapeople = new HashMap();
  } 

  int[][] updatePeople() {
    ArrayList removeList = new ArrayList();
    Iterator i = cyapeople.entrySet().iterator();
    while (i.hasNext()) {
      Map.Entry person = (Map.Entry)i.next();
      String pKey = (String)person.getKey();
      int[] pData = (int[])person.getValue();
      if ( millis() > (pData[1]+pData[2]) ) {
        removeList.add(pKey);
      }
    }
    for (int j=0; j < removeList.size(); j++) {
      String pKeyToRemove = (String)removeList.get(j);
      cyapeople.remove(pKeyToRemove);
    }
    if (cyapeople.size() > 0) {
      int[][] people = new int[cyapeople.size()][];
      int p=0;
      i = cyapeople.entrySet().iterator();
      while (i.hasNext()) {
        Map.Entry person = (Map.Entry)i.next();
        int[] pData = (int[])person.getValue();
        people[p] = pData;
        p++;
      }
      return people;
    } 
    else {
      int[][] people = new int[0][];
      return people; 
    }
  }

  void oscEvent(OscMessage theOscMessage) {
    if (theOscMessage.addrPattern().equals("cya/personMoved/")){
      int pID = theOscMessage.get(0).intValue();
      String pKey = str(pID);
      int pTimeStamp;
      int pPreviousX;
      int pPreviousY;
      if (cyapeople.containsKey(pKey)) {
        pTimeStamp = ((int[])cyapeople.get(pKey))[1];
        pPreviousX = ((int[])cyapeople.get(pKey))[3];
        pPreviousY = ((int[])cyapeople.get(pKey))[4];
      } 
      else {
        pTimeStamp = millis();
        pPreviousX = -1;
        pPreviousY = -1;
      }
      int pAge = theOscMessage.get(1).intValue() * 100;
      if (pAge > millis()) {
        pAge = millis();
      }
      int pX = int(theOscMessage.get(2).floatValue() * width);
      int pY = int(theOscMessage.get(3).floatValue() * height);
      int pWidth = int(theOscMessage.get(8).floatValue() * width); 
      int pHeight = int(theOscMessage.get(9).floatValue() * height);
      int[] pData = { 
        pID, pTimeStamp, pAge, pX, pY, pPreviousX, pPreviousY, pWidth, pHeight                           };
      cyapeople.put(pKey, pData);
    }
  }
}



