CYAClient cya;

void setup() {
  size(640,480);
  cya = new CYAClient(this,12000); // connect to the CYA PeopleVision application using port 12000

  rectMode(CENTER);
  ellipseMode(CENTER);
  smooth();
}

void draw() {
  background(0);

  // get the array of people
  int[][] people = cya.updatePeople();
  if (people.length > 0) {
    for (int i=0; i < people.length; i++) {
      // debug the information about each person
      println("person " + people[i][0] + " who started after " + (people[i][1]/1000) + " seconds, has been here for " + (people[i][2]/1000) + " seconds, and is at location " + people[i][3] + "," + people[i][4] + ", but was at location " + people[i][5] + "," + people[i][6] + ", and has a width of " + people[i][7] + " and a height of " + people[i][8] );    
      // check to see if the person is standing still (set color to red if they are)
      if (people[i][3] == people[i][5] && people[i][4] == people[i][6]) {  
        stroke(255,0,0);
        fill(0);
      } 
      else {
        stroke(255);
        fill(0);
      }    
      // draw the rectangle and center of the person
      rect(width-people[i][3], people[i][4], people[i][7], people[i][8]);
      ellipse(width-people[i][3], people[i][4], 10, 10);
    }
  }
}
